[xxx] = textread('expSIM.txt','%s');

[T,R] = strtok(char(xxx(1)),':');
[workingdir] = strtok(R,':');


[T,R] = strtok(char(xxx(2)),':');
[designfile] = strtok(R,':');

[T,R] = strtok(char(xxx(3)),':');
[Tr] = str2double(strtok(R,':'));

[T,R] = strtok(char(xxx(4)),':');
[xdim] = str2double(strtok(R,':'));

[T,R] = strtok(char(xxx(5)),':');
[ydim] = str2double(strtok(R,':'));


[T,R] = strtok(char(xxx(6)),':');
[Tausyn] = strtok(R,':');

[T,R] = strtok(char(xxx(7)),':');
[TauaFix] = str2double(strtok(R,':'));

[T,R] = strtok(char(xxx(8)),':');
[TaubFix] = str2double(strtok(R,':'));

[T,R] = strtok(char(xxx(9)),':');
[DelayRange] = str2double(strtok(R,':'));

[T,R] = strtok(char(xxx(10)),':');
[DelayResolution] = str2double(strtok(R,':'));


sprintf('Working Dir is %s\n',workingdir)  
sprintf('Paradigm file is %s\n',designfile) 
sprintf('Tr is %d\n', Tr) 
sprintf('x by y dimensions are %d by %d\n', xdim,ydim) 
sprintf('Estimate the time constants? %s\n', Tausyn)
sprintf('Flow time constant is %d\n', TauaFix)
sprintf('Volume time constant is %d\n', TaubFix)
sprintf('Delay Range is %d\n', DelayRange)
sprintf('Delay resolution is is %d\n', DelayResolution)

exptstub=['fmc_'];
filestub = [workingdir exptstub];


infile=load(designfile);
[nFFT,J]=dyadlength(PadDyad(infile));
[nScan, nCond]=size(infile);

if(nCond>1)
infile=sum(infile');
end


[zeta, zetafft, zetatrunc, slope]=initialisezeta(infile, nScan, nFFT, Tr, TauaFix, TaubFix);




finalact=zeros(xdim,ydim);
finalact_raw=zeros(xdim,ydim);




jk=0;
while 1
	   
if(jk<10),
jj=['00' num2str(jk)];
elseif((jk>=10) & (jk<100)),
jj=['0' num2str(jk)];
elseif((jk>=100) & (jk<1000)),
jj=['' num2str(jk)];
end
testname=[filestub jj];
filename=[testname '.bshort'];
matname=[exptstub jj];
if(~exist(filename)),break, 
else
numslices=jk+1;
end
sprintf(['Reading file' filename])
fp=fopen(filename,'rb','b');
		fseek(fp,0,1);
		filesize=ftell(fp);  %ascertain file size
		fseek(fp,0,-1);      %rewind to beginning
		xx=[];
		while 1
		    slice=fread(fp, [xdim ydim], 'short');
		    xx=cat(3,xx,slice);
		    if (ftell(fp)==filesize),break,end
		end
		fclose(fp);
		eval([matname '= xx;']);	
jk=jk+1;
end



for(slindex=1:numslices)

if(slindex<=10),
sli=['00' num2str(slindex-1)];
elseif((slindex>10) & (slindex<100)),
sli=['0' num2str(slindex-1)];
elseif((slindex>=100) & (slindex<1000)),
sli=['' num2str(slindex-1)];
end

matname = [exptstub sli];


%dyadts=prep(ts, nScan, nFFT);

xxdata=eval(matname);

% optional low frequency trend removal
RT=Tr;
XX=[];
HPF = []; HPFnames = '';
for k = 1:2
HPF = [HPF, cos(k*pi*([1:nScan]-1)'/(nScan-1))];
HPFnames = ...
strvcat(HPFnames,sprintf('LowHz (%4.0fs)',2*RT*nScan/k));
end 
onesvec=ones(1, nScan)';
XX=[onesvec, HPF];

%optional spatial smoothing
%filtsiz=[3 3 1];
%filtstd=.8;
%ypa=smooth3(xxdata,'gaussian',filtsiz,filtstd);


dyadxxfft=zeros(xdim,ydim,nFFT);
for(ii=1:xdim)
for(jj=1:ydim)

ts1(1:nScan)=xxdata(ii,jj,1:nScan);
ts=remtrend(ts1,nScan,XX);

tempvec=prep(ts, nScan, nFFT);

dyadxxfft(ii,jj,1:nFFT)=fft(tempvec(1:nFFT),nFFT);


end
end

%ypa=smooth3(dyadxxfft,'gaussian',filtsiz,filtstd);

%[pfa, pfb, pfc, pslope, pmean, psigma_ar, psigma_whi, p_ar, pdelay ] = lrst_reg( dyadxxfft, slope, zetafft, nFFT, nScan, xdim, ydim, .5, 4);

[pfa, pfb, pfc, pslope, pmean, psigma_ar, psigma_whi, p_ar, pdelay, Omega_a, Omega_b, Omega_c, taua, taub] ...
 = lrst_regforSpatWavs( dyadxxfft, slope, nFFT, nScan, Tr, infile, xdim, ydim, DelayResolution, DelayRange,...
 Tausyn, TauaFix, TaubFix);
 fix(clock)

for(xx=1:xdim)
for(yy=1:ydim)
[zeta, zetafft, zetatrunc, slope]=initialisezeta(infile, nScan, nFFT, Tr, taua(xx,yy), taub(xx,yy));
%%%reconstruct and find final activation strength
reconstruction = pfa(xx,yy)*zetafft(1,:) + pfb(xx,yy)*zetafft(2,:) + pfc(xx,yy)*zetafft(3,:);
dyadts(1:nScan)=xxdata(xx,yy,1:nScan);
if(sum(dyadts)>1)
%hold off;
plot(dyadts(1:nScan)-pslope(xx,yy)*slope(1:nScan)-pmean(xx,yy));
%plot(dyadts(1:nScan)-pmean(xx,yy));
hold on;
%plot(pslope(xx,yy)*slope(1:nScan),'c')
%plot(pslope(xx,yy)*slope(1:nScan),'c')
tdrecon=real(ifft(reconstruction,nFFT));
plot(delayed(tdrecon(1:nScan),2),'r');


finalnois =  psigma_whi(xx,yy) + psigma_ar(xx,yy)./abs(1-p_ar(xx,yy)*exp(-2*pi*i*[0:(nFFT)-1]/(nFFT))).^2;
%reconfft = fft(reconstruction,nFFT);

finalact(xx,yy)=(1/nFFT)*sum(abs(reconstruction(2:nFFT/2)).^2./finalnois(2:nFFT/2));
finalact_raw(xx,yy)=(1/nFFT)*sum(abs(reconstruction(2:nFFT/2)).^2);

hold off;
title(['xx is' int2str(xx) ' yy is' int2str(yy)])
%pause
end %if


end
end


end %sli index

%%%%%%%%%%%%%%%%%%%%%%%%%%%End of processing%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%










%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%ADDENDUM%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
break;
%ts1(1:nScan)=xxdata(15,40,1:nScan);
%manufacture a signal

[zeta, zetafft, zetatrunc, slope]=initialisezeta(infile, nScan, nFFT, Tr, 1.5, 12);
ftest=[20 2 1];
sig(1:nScan) = delayed(ftest*zeta,3);
whitenoise=randn(1,nScan);
whitenoise=whitenoise*(1/sqrt(var(whitenoise)));
whitenoise=sqrt(50)*whitenoise;
colour=filter([1], [1 -.5], whitenoise);

whitenoise1 = randn(1,nScan);
whitenoise1=sqrt(25)*whitenoise1*(1/sqrt(var(whitenoise1)));

addmean=1000;
addslope=(0:nScan-1);
dyadts = sig + colour + whitenoise1 + addmean +.1*addslope;


dyadts=prep(dyadts, nScan, nFFT);
TauaFix=1.5;
TaubFix=12;

[zeta, zetafft, zetatrunc, slope]=initialisezeta(infile, nScan, nFFT, Tr, TauaFix, TaubFix);
[Taua, Taub, pf,pslope, pmean, psigma_ar, psigma_whi, p_ar, pdelay, Gamma] = ...
lrstataus( dyadts, slope, zetafft, zetatrunc, nFFT, nScan, Tr, infile, DelayResolution, DelayRange, 'n');
 
 
 
[zeta, zetafft, zetatrunc, slope]=initialisezeta(infile, nScan, nFFT, Tr, Taua, Taub);
 
 reconstruction = pf(1:3)*zetafft;
plot(dyadts(1:nScan)-pslope*slope(1:nScan)-pmean);
hold on;
tdrecon=real(ifft(reconstruction,nFFT));
plot(delayed(tdrecon(1:nScan),pdelay),'r');
finalnois = psigma_whi + psigma_ar./abs(1-p_ar*exp(-2*pi*i*[0:(nFFT)-1]/(nFFT))).^2;
finalact=(1/nFFT)*sum(abs(reconstruction(1:nFFT/2)).^2./finalnois(1:nFFT/2));
hold off;
title(['ii is' int2str(ii) ' jj is' int2str(jj)])
drawnow;
 
 
 






