function [tstat, pval, se]=CalcStandardErrorsLRST(y, zetafft, slopefft, meanfft, pmean, pslope, fa, fb, fc, white_amp, ar_amp, q, n);


fs=[fa fb fc];
beta=[pmean pslope fs]';
nFFT=length(slopefft);

X=[meanfft; slopefft; zetafft];

[p,nFFT] = size(X);


dfe = n - p;

Xifft=real(ifft(X,nFFT,2));
yhat=beta'*Xifft(:,1:n)';

%calculate anscombe residuals
y=squeeze(y)';
dd=(y-yhat).^2;
%ssr=sum(dd);
%dev=ssr;
%resids=y-yhat;
%goodnessfit = sqrt(ssr / dfe);


Nois = white_amp + ar_amp./abs(1-q*exp(-2*pi*i*[0:(nFFT)-1]/(nFFT))).^2;
%W = diag(Nois);

% take qr decomposition to get information matrix and get standard errors
%XW=(X'/W)';

for(ii=1:p)
XW(ii,1:nFFT)=X(1:nFFT,ii)'./Nois;
end
XW=XW';

[Q,R]=qr(XW,0);
RI = R\eye(p);
C = RI * RI';
%C=C * (ar_amp*(1-q^2)+white_amp);
%C = C * goodnessfit^2;
se = real(sqrt(max(eps,diag(C))));
CorrCoeff = C ./ (se * se');
tstat = beta ./ se;
%tstatmod=sum(real(tstat(3:5).^2));
pval = 2 * tcdf(-abs(tstat), dfe);

% invert if necessary...   tstat=-(tinv(.5*.1593,dfe)); 
