%[xxx] = textread('expSKB.txt','%s');

xdim=64;
ydim=64;
nparams=11;

[T,R] = strtok(char(xxx(1)),':');
[stemname] = strtok(R,':');

[T,R] = strtok(char(xxx(2)),':');
[designfile] = strtok(R,':');

[T,R] = strtok(char(xxx(3)),':');
[outputdir] = strtok(R,':');

[T,R] = strtok(char(xxx(4)),':');
[TR] = str2double(strtok(R,':'));

[T,R] = strtok(char(xxx(5)),':');
[Tausyn] = strtok(R,':');

[T,R] = strtok(char(xxx(6)),':');
[TauaFix] = str2double(strtok(R,':'));

[T,R] = strtok(char(xxx(7)),':');
[TaubFix] = str2double(strtok(R,':'));

[T,R] = strtok(char(xxx(8)),':');
[DelayRange] = str2double(strtok(R,':'));

[T,R] = strtok(char(xxx(9)),':');
[DelayResolution] = str2double(strtok(R,':'));


sprintf('Experiment stub is %s\n', stemname)  
sprintf('Paradigm file is %s\n', designfile)
sprintf('Output Directory is %s\n', outputdir)
sprintf('TR is %d\n', TR)
sprintf('Estimate the time constants? %s\n', Tausyn)
sprintf('Flow time constant is %d\n', TauaFix)
sprintf('Volume time constant is %d\n', TaubFix)
sprintf('Delay Range is %d\n', DelayRange)
sprintf('Delay resolution is is %d\n', DelayResolution)

filestub = [stemname '_'];

par = fmri_ldpar(designfile);
ntrs=((par(length(par),1)+TR)/TR);
Nc = length(unique([par(:,2); 0])) - 1;
Xfir = fmri_par2scm(par,Nc+1,ntrs,TR,1,0);
% Nc is the number of non-null conditions %

[nFFT,J]=dyadlength(PadDyad(Xfir(:,1)));
[zeta, zetafft, slopefft]=initialisezeta(Xfir, ntrs, nFFT, TR, TauaFix, TaubFix);
meanfft=fft(ones(1,nFFT));
finalact=zeros(xdim,ydim);
finalact_raw=zeros(xdim,ydim);
dyadxxfft=zeros(xdim,ydim,nFFT);
m=zeros(xdim,ydim,nparams);
tstat_a=zeros(xdim,ydim);
tstat_b=zeros(xdim,ydim);
tstat_c=zeros(xdim,ydim);
pval_a=zeros(xdim,ydim);
pval_b=zeros(xdim,ydim);
pval_c=zeros(xdim,ydim);
SE_a=zeros(xdim,ydim);
SE_b=zeros(xdim,ydim);
SE_c=zeros(xdim,ydim);



%%%%%%%%%%%make a low pass filter

XX=[];
HPF = []; HPFnames = '';
for k = 1:2
HPF = [HPF, cos(k*pi*([1:ntrs]-1)'/(ntrs-1))];
HPFnames = ...
strvcat(HPFnames,sprintf('LowHz (%4.0fs)',2*TR*ntrs/k));
end 
onesvec=ones(1, ntrs)';
XX=[onesvec, HPF];




jk=0;
while 1

xxdata = fast_ldbslice(stemname,jk);
if(isempty(xxdata))
  fprintf('ERROR: could not load %s\n',stemname);
  return;
end

%do some preprocessing (zero pad, fft).
for(xx=1:xdim)
for(yy=1:ydim)
ts1(1:ntrs)=xxdata(xx,yy,1:ntrs);
%ts=remtrend(ts1,ntrs,XX);
tempvec=prep(ts1, ntrs, nFFT);
dyadxxfft(xx,yy,1:nFFT)=fft(tempvec(1:nFFT),nFFT);
end
end


[nn,nConds]=size(Xfir);
for(nn=1:nConds)

%%run LRST
[pfa, pfb, pfc, pslope, pmean, psigma_ar, psigma_whi, p_ar, pdelay, Omega_a, Omega_b, Omega_c, taua, taub] ...
 = lrst_regforSpatWavs( dyadxxfft, slopefft, nFFT, ntrs, TR, Xfir(:,nn), xdim, ydim, DelayResolution, DelayRange,...
 Tausyn, TauaFix, TaubFix);


for(ii=1:xdim)
  for(jj=1:ydim)
   initialfits(nn,ii,jj,1:nFFT)=exp(i*2*pi*[(0:nFFT-1)./nFFT]*(-pdelay(ii,jj))).*(pfa(ii,jj)*zetafft(1,:)+pfb(ii,jj)*zetafft(2,:)...
   +pfc(ii,jj)*zetafft(3,:));
  end
end

end %of conditions


%subtract off data
pseudofits=zeros(size(initialfits));
for(nn=1:nConds)
   for(pp=1:nConds)
	  if(nn~=pp)
	pseudofits(nn,:,:,:) = pseudofits(nn,:,:,:) + initialfits(pp,:,:,:);
      end
   end
end



for(nn=1:nConds)
    
tempmat=squeeze(pseudofits(nn,:,:,:));
pseudodata(:,:,:) = dyadxxfft(:,:,:)-tempmat;


[pfa, pfb, pfc, pslope, pmean, psigma_ar, psigma_whi, p_ar, pdelay, Omega_a, Omega_b, Omega_c, taua, taub] ...
 = lrst_regforSpatWavs(pseudodata, slopefft, nFFT, ntrs, TR, Xfir(:,nn), xdim, ydim, DelayResolution, DelayRange,...
 Tausyn, TauaFix, TaubFix);

m(:,:,1) =pfa;
m(:,:,2) =pfb;
m(:,:,3) =pfc;
m(:,:,4) =pslope;
m(:,:,5) =pmean;
m(:,:,6) =psigma_ar;
m(:,:,7) =psigma_whi;
m(:,:,8) =p_ar;
m(:,:,9) =pdelay;
m(:,:,10)=taua;
m(:,:,11)=taub;
%%%%%more to come

outfile=sprintf([outputdir '%s%03d%s%d%s'],'/Slice_',jk,'_C_',nn,'.bfloat');
fmri_svbfile(m,outfile);


end





for(xx=1:xdim)
for(yy=1:ydim)
tsfft(1:nFFT)=dyadxxfft(xx,yy,1:nFFT);
%[zeta, zetafft]=initialisezeta(Xfir(:,1), ntrs, nFFT, TR, taua(xx,yy), taub(xx,yy));
[Fstat]=CalcStandardErrorsLRST_v3(tsfft, Xfir, slopefft, meanfft, pmean(xx,yy), pslope(xx,yy), pfa(xx,yy),...
 pfb(xx,yy), pfc(xx,yy), psigma_whi(xx,yy), psigma_ar(xx,yy), p_ar(xx,yy), R, ntrs, nconds);
 tstat_a(xx,yy)=Fstat;
end
end
% output some results.


m(:,:,1) =pfa;
m(:,:,2) =pfb;
m(:,:,3) =pfc;
m(:,:,4) =pslope;
m(:,:,5) =pmean;
m(:,:,6) =psigma_ar;
m(:,:,7) =psigma_whi;
m(:,:,8) =p_ar;
m(:,:,9) =pdelay;
m(:,:,10)=taua;
m(:,:,11)=taub;
%%%%%more to come

outfile=sprintf([outputdir '%s%03d'],'/results_',jk);
fmri_svbfile(m,filename);

jk=jk+1;
end







for(slindex=1:numslices)

if(slindex<=10),
sli=['00' num2str(slindex-1)];
elseif((slindex>10) & (slindex<100)),
sli=['0' num2str(slindex-1)];
elseif((slindex>=100) & (slindex<1000)),
sli=['' num2str(slindex-1)];
end

matname = [exptstub sli];


%dyadts=prep(ts, nScan, nFFT);

xxdata=eval(matname);

% optional low frequency trend removal

%optional spatial smoothing
%filtsiz=[3 3 1];
%filtstd=.8;
%ypa=smooth3(xxdata,'gaussian',filtsiz,filtstd);



for(xx=1:xdim)
for(yy=1:ydim)

ts1(1:ntrs)=xxdata(xx,yy,1:ntrs);
ts=remtrend(ts1,ntrs,XX);

tempvec=prep(ts, ntrs, nFFT);

dyadxxfft(xx,yy,1:nFFT)=fft(tempvec(1:nFFT),nFFT);


end
end

%ypa=smooth3(dyadxxfft,'gaussian',filtsiz,filtstd);

%[pfa, pfb, pfc, pslope, pmean, psigma_ar, psigma_whi, p_ar, pdelay ] = lrst_reg( dyadxxfft, slope, zetafft, nFFT, nScan, xdim, ydim, .5, 4);

[pfa, pfb, pfc, pslope, pmean, psigma_ar, psigma_whi, p_ar, pdelay, Omega_a, Omega_b, Omega_c, taua, taub] ...
 = lrst_regforSpatWavs( dyadxxfft, slope, nFFT, nScan, Tr, infile, xdim, ydim, DelayResolution, DelayRange,...
 Tausyn, TauaFix, TaubFix);
 fix(clock)

for(xx=1:xdim)
for(yy=1:ydim)
[zeta, zetafft]=initialisezeta(infile, ntrs, nFFT, TR, taua(xx,yy), taub(xx,yy));
%%%reconstruct and find final activation strength
reconstruction = (pfa(xx,yy))*zetafft(1,:) + (pfb(xx,yy))*zetafft(2,:)...
    + (pfc(xx,yy))*zetafft(3,:);
dyadts(1:ntrs)=xxdata(xx,yy,1:ntrs);
if(sum(dyadts)>1)
%hold off;
plot(dyadts(1:ntrs)-pslope(xx,yy)*slope(1:ntrs)-pmean(xx,yy));
%plot(dyadts(1:nScan)-pmean(xx,yy));
hold on;
%plot(pslope(xx,yy)*slope(1:nScan),'c')
%plot(pslope(xx,yy)*slope(1:nScan),'c')
tdrecon=real(ifft(reconstruction,nFFT));
plot(delayed(tdrecon(1:ntrs),2),'r');


finalnois =  psigma_whi(xx,yy) + psigma_ar(xx,yy)./abs(1-p_ar(xx,yy)*exp(-2*pi*i*[0:(nFFT)-1]/(nFFT))).^2;
%reconfft = fft(reconstruction,nFFT);

finalact(xx,yy)=(1/nFFT)*sum(abs(reconstruction(2:nFFT/2)).^2./finalnois(2:nFFT/2));
finalact_raw(xx,yy)=(1/nFFT)*sum(abs(reconstruction(2:nFFT/2)).^2);

hold off;
title(['xx is' int2str(xx) ' yy is' int2str(yy)])
%pause
end %if


end
end


end %sli index

%%%%%%%%%%%%%%%%%%%%%%%%%%%End of processing%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%










%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%ADDENDUM%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
break;
%ts1(1:nScan)=xxdata(15,40,1:nScan);
%manufacture a signal

[zeta, zetafft, zetatrunc, slope]=initialisezeta(infile, nScan, nFFT, Tr, 1.5, 12);
ftest=[20 2 1];
sig(1:nScan) = delayed(ftest*zeta,3);
whitenoise=randn(1,nScan);
whitenoise=whitenoise*(1/sqrt(var(whitenoise)));
whitenoise=sqrt(50)*whitenoise;
colour=filter([1], [1 -.5], whitenoise);

whitenoise1 = randn(1,nScan);
whitenoise1=sqrt(25)*whitenoise1*(1/sqrt(var(whitenoise1)));

addmean=1000;
addslope=(0:nScan-1);
dyadts = sig + colour + whitenoise1 + addmean +.1*addslope;


dyadts=prep(dyadts, nScan, nFFT);
TauaFix=1.5;
TaubFix=12;

[zeta, zetafft, zetatrunc, slope]=initialisezeta(infile, nScan, nFFT, Tr, TauaFix, TaubFix);
[Taua, Taub, pf,pslope, pmean, psigma_ar, psigma_whi, p_ar, pdelay, Gamma] = ...
lrstataus( dyadts, slope, zetafft, zetatrunc, nFFT, ntrs, TR, infile, DelayResolution, DelayRange, 'n');
 
 
 
[zeta, zetafft, zetatrunc, slope]=initialisezeta(infile, ntrs, nFFT, TR, Taua, Taub);
 
 reconstruction = pf(1:3)*zetafft;
plot(dyadts(1:ntrs)-pslope*slope(1:ntrs)-pmean);
hold on;
tdrecon=real(ifft(reconstruction,nFFT));
plot(delayed(tdrecon(1:ntrs),pdelay),'r');
finalnois = psigma_whi + psigma_ar./abs(1-p_ar*exp(-2*pi*i*[0:(nFFT)-1]/(nFFT))).^2;
finalact=(1/nFFT)*sum(abs(reconstruction(1:nFFT/2)).^2./finalnois(1:nFFT/2));
hold off;
title(['xx is' int2str(xx) ' yy is' int2str(yy)])
drawnow;
 
 
 






