function [zeta, dzetafft, slopefft]=initialisezeta(infile,n,nFFT, Tr, O2_delay,V_delay)


if(nargout>2)
slopefft = fft((0:nFFT-1),nFFT);
end

%O2_delay = 1.5;
%V_delay = 12;
delay_a = O2_delay/Tr;
delay_b = V_delay/Tr;
%delay_a = O2_delay;
%delay_b = V_delay;
t=Tr*(0:n-1);

alpha_a=exp(-1/(delay_a+eps));
alpha_b=exp(-1/(delay_b+eps));
Ka=(1-alpha_a)*(1-alpha_a);


%filter via a differencing step.

zeta=zeros(3,n);
for(ii=3:n)
zeta(1, ii) = Ka*infile(ii) + 2*alpha_a*zeta(1, ii-1) - alpha_a*alpha_a*zeta(1, ii-2);
end
for(ii=2:n)
zeta(2, ii) = infile(ii) + alpha_b*zeta(2, ii-1);
end
zeta(3, 1:n)=zeta(1, 1:n).*zeta(2, 1:n);



zetapad=zeros(3,n);
zetapad(1,1:n)=zeta(1,1:n);
meanzeta1=mean(zeta(1,:));
for(ll=n+1:nFFT)
     zetapad(1,ll)= meanzeta1;
end

zetapad(2, 1:n)=zeta(2, 1:n);
meanzeta2=mean(zeta(2,:));
for(ll=n+1:nFFT)
     zetapad(2,ll)= meanzeta2;
end


zetapad(3,1:n)=zeta(3,1:n);
meanzeta3=mean(zeta(3,:));
for(ll=n+1:nFFT)
     zetapad(3,ll)= meanzeta3;
end

dzetafft=fft(zetapad, nFFT, 2);

