#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

char *progname;

int main(int argc, char *argv[])
{

	int xdim, ydim, ns, tp;
	char *c;
	FILE *fin, *fout;
	char fname[200];
	int i, t;
	unsigned char *buf;

	progname = strrchr(argv[0], '/');
	progname = (progname == NULL ? argv[0] : progname+1);

	if(argc < 7)
		{
		fprintf(stderr, "usage: %s <input brik file> <output bshort stem> <voxels in x> <voxels in y> <number of slices> <time points>\n", progname);
		exit(1);
		}

	xdim = strtol(argv[3], &c, 10);
	if(c != NULL && *c != '\0')
		{
		fprintf(stderr, "%s: bad xdim value %s\n", progname, argv[3]);
		exit(1);
		}

	ydim = strtol(argv[4], &c, 10);
	if(c != NULL && *c != '\0')
		{
		fprintf(stderr, "%s: bad ydim value %s\n", progname, argv[4]);
		exit(1);
		}

	ns = strtol(argv[5], &c, 10);
	if(c != NULL && *c != '\0')
		{
		fprintf(stderr, "%s: bad xdim value %s\n", progname, argv[5]);
		exit(1);
		}

	tp = strtol(argv[6], &c, 10);
	if(c != NULL && *c != '\0')
		{
		fprintf(stderr, "%s: bad xdim value %s\n", progname, argv[6]);
		exit(1);
		}

	strcpy(fname, argv[1]);
	if((fin = fopen(fname, "r")) == NULL)
		{
		if(strcmp(&(fname[strlen(fname)-5]), ".BRIK") != 0)
			{
			strcat(fname, ".BRIK");
			if((fin = fopen(fname, "r")) == NULL)
				{
				fprintf(stderr, "%s: can't open file %s (or %s) for reading, exiting\n", progname, argv[1], fname);
				exit(1);
				}
			}
		else
			{
			fprintf(stderr, "%s: can't open file %s for reading, exiting\n", progname, fname);
			exit(1);
			}
		}

	if((buf = (unsigned char *)malloc(2 * xdim * ydim * ns * tp)) == NULL)
		{
		fclose(fin);
		fprintf(stderr, "%s: can't allocate memory\n", progname);
		exit(1);
		}

	if((i = fread(buf, 1, 2 * xdim * ydim * ns * tp, fin)) != 2 * xdim * ydim * ns * tp)
		{
		fclose(fin);
		fprintf(stderr, "%s: error reading from file %s (%d of %d bytes read)\n", progname, fname, i, 2 * xdim * ydim * ns * tp);
		exit(1);
		}

	fclose(fin);

	for(i = 0;i < ns;i++)
		{
		sprintf(fname, "%s_%03d.hdr", argv[2], i);
		if((fout = fopen(fname, "w")) == NULL)
			{
			fprintf(stderr, "%s: can't open file %s for writing, exiting\n", progname, fname);
			exit(1);
			}
		fprintf(fout, "%d %d %d %d\n", xdim, ydim, tp, 0);
		fclose(fout);

		sprintf(fname, "%s_%03d.bshort", argv[2], i);
		if((fout = fopen(fname, "w")) == NULL)
			{
			fprintf(stderr, "%s: can't open file %s for writing, exiting\n", progname, fname);
			exit(1);
			}
		for(t = 0;t < tp;t++)
			fwrite(&buf[2*(t*xdim*ydim*ns+xdim*ydim*i)], 1, 2 * xdim * ydim, fout);
		fclose(fout);
		
		}

	free(buf);

	exit(0);

}	/*	end main()	*/

/*	EOF	*/
