#include<stdio.h>
#include<stdlib.h>

long int FileSizeBytes(FILE *pF);

FILE *infp,*outfp;
char *c;
int i,j,k;
int offset;
 
int main(int argc, char **argv)
{
  if(argc != 4){
    fprintf(stderr,"USAGE: btail infile outfile offset\n");
    exit(1);
  }
  sscanf(argv[3],"%d",&offset);
  
  infp = fopen(argv[1],"rb");
  if(infp==NULL){
    fprintf(stderr,"Error: cannot open %s\n",argv[1]);
    exit(1);
  } 

  k = FileSizeBytes(infp);
  c = (char *) malloc(k*sizeof(char));
  i = fread(c, sizeof(char), k, infp);
  fclose(infp);

  if(offset >= k){
    fprintf(stderr,"Error: offset (%d) exceeds file size (%d)\n",
	    offset,k);
    exit(1);
  } 
  
  outfp = fopen(argv[2],"wb");
  if(outfp==NULL){
    fprintf(stderr,"Error: cannot open outfile %s\n",argv[3]);
    exit(1);
  } 

  i = fwrite((void *)(&c[offset]),sizeof(char),k-offset,outfp);
  fclose(outfp);

  return(0);
}

long int FileSizeBytes(FILE *pF)
{
    long int CurPos, EndPos;
    
    CurPos = ftell(pF);
    fseek(pF,0L,SEEK_END);
    EndPos = ftell(pF);
    fseek(pF,0L,CurPos);
    return(EndPos);
}
