#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>

struct stat buf1, buf2;
int err;

int main(int argc, char **argv)
{

  if(argc != 3){
    fprintf(stderr,"USAGE: cmpmodtime file1 file2\n");
    fprintf(stderr," Returns:\n");
    fprintf(stderr," +1 : file1 modified more recently than file2\n");
    fprintf(stderr,"  0 : mod dates/times are equal\n");
    fprintf(stderr," -1 : file2 modified more recently than file1\n");
    exit(1);
  }

  err = stat(argv[1], &buf1);
  if(err){
    fprintf(stderr,"ERROR %d: stat(%s) \n",err,argv[1]);
    exit(1);
  }

  err = stat(argv[2], &buf2);
  if(err){
    fprintf(stderr,"ERROR %d: stat(%s) \n",err,argv[2]);
    exit(1);
  }

  if(buf1.st_mtime == buf2.st_mtime) printf("0");
  else if(buf1.st_mtime < buf2.st_mtime) printf("-1");
  else printf("1");

  return(0);
  exit(0);
}
