/**************************************************************
 Name:    bavg.c
 Purpose: computes the global average for a bshort or bfloat
 $Id: bavg.c,v 1.1 1999/05/19 20:16:42 greve Exp greve $
 **************************************************************/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <unistd.h>
#include <limits.h>
#include <errno.h>
#include <sys/stat.h>

#define  BSHORT 0
#define  BFLOAT 1

long int getfilesize(char *fname);
int byteswapbuf(void *buf, long int nbufbytes);

FILE *infp, *outfp;
long i,j,k,n,nbytes,n0,n1,m0,m1,Nv;
long r,r1,r2,c,c1,c2,nrows=128,ncols=128;
short *dbs;
float *dbf;
double sum, sumsqrd;
double avg, std, var;
char  ext[6];
char  infname[256];
char  outfname[256];
int   fl,btype;
short int sval;
float     fval;
float    val = 1000;
char * ctmp, OS[256];

int main(int argc, char **argv)
{

  /*printf("%d\n",argc);*/
  if(argc != 7 && argc != 8){
    fprintf(stderr,"USAGE: setbfileroi infile r1 c1 r2 c2 val <outfile>\n");
    exit(1);
  }

  sval = (short int) val;
  fval = (float) val;  

  Nv = nrows*ncols;

  sprintf(infname,"%s",argv[1]);
  sscanf(argv[2],"%d",&r1);
  sscanf(argv[3],"%d",&c1);
  sscanf(argv[4],"%d",&r2);
  sscanf(argv[5],"%d",&c2);
  sscanf(argv[6],"%f",&val);
  if(argc == 8) strcpy(outfname,argv[7]);
  else          strcpy(outfname,infname);

  ctmp = getenv("OS");
  strcpy(OS,ctmp);
  printf("OS = %s\n",OS);
  if(strcmp(OS,"Linux")==0) printf("Swapping bytes\n");

  /******* get extension *************/
  fl = strlen(infname);
  sprintf(ext,"%s",&(infname[fl-6]));
  if(!strcmp(ext,"bshort"))      btype = BSHORT;
  else if(!strcmp(ext,"bfloat")) btype = BFLOAT;  
  else{
    fprintf(stderr,"Extension %s not recognized\n",ext);
    exit(1);
  }

  /******** open the input file ******/  
  infp = fopen(infname,"rb");
  if(infp==NULL){
    fprintf(stderr,"Error: cannot open %s\n",infname);
    exit(1);
  } 

  /******* get number of bytes in file ********/
  nbytes = getfilesize(infname);

  /****** Load the data in ***************/
  if(btype == BSHORT){
    k = nbytes/sizeof(short);
    dbs = (short *) malloc(k*sizeof(short));
    i = fread(dbs, sizeof(short), k, infp);
    if(strcmp(OS,"Linux")==0) 
      byteswapbuf((void *) dbs, nbytes);
  }
  else{
    k = nbytes/sizeof(float);
    dbf = (float *) malloc(k*sizeof(float));
    i = fread(dbf, sizeof(float), k, infp);
    if(strcmp(OS,"Linux")==0) 
      byteswapbuf((void *) dbf, nbytes);
  }
  fclose(infp);


  for(r=r1;r<r2;r++){
    for(c=c1;c<c2;c++){
      n = r*ncols + c;
      if(btype == BSHORT) dbs[n] = sval;
      else                dbf[n] = fval;
    }
  }
  
  /******** open the input file ******/  
  outfp = fopen(outfname,"wb");
  if(outfp==NULL){
    fprintf(stderr,"Error: cannot open %s\n",outfname);
    exit(1);
  } 

  if(btype == BSHORT){
    if(strcmp(OS,"Linux")==0) byteswapbuf((void *) dbs, nbytes);
    fwrite(dbs, sizeof(short int), Nv, outfp);
  }
  else{
    if(strcmp(OS,"Linux")==0) byteswapbuf((void *) dbf, nbytes);
    fwrite(dbf, sizeof(float), Nv, outfp);
  }
  fclose(outfp);

  return(0);
}

long int getfilesize(char *fname)
{
  struct stat filestat;
  int e;
  
  e = stat(fname, &filestat);
  if(e != 0){
    fprintf(stderr,"ERROR: Input File %s\n",fname);
    fprintf(stderr,"%s\n",strerror(errno));
    exit(1);
  }

  return((long int)filestat.st_size);
}

/* ------------------------- */
int byteswapbuf(void *buf, long int nbufbytes)
{
  register char *cbuf,c;
  register long int n, nmax;

  nmax = nbufbytes;
  cbuf = (char *)buf;
  for(n=0;n<nmax;n+=4){
    c = *cbuf;
    *cbuf = *(cbuf+3);
    *(cbuf+3) = c;

    c = *(cbuf+1);
    *(cbuf+1) = *(cbuf+2);
    *(cbuf+2) = c;

    cbuf += 4;
  }
  return(0);
}
