function name = dirname(path)
% name = dirname(path)
% 
% This is an attempt to recreate the unix dirname command
% in matlab.
% $Id$

if(nargin ~= 1)
  msg = 'USAGE: name = dirname(path)'
  qoe(msg); error(msg);
end

name = [];
len = length(path);

if(len == 1) 
  if(strcmp(path,'/'))
    name = '/';
  else
    name = '.';
  end
  return;
end

for n = len-1:-1:1
  if(strcmp(path(n),'/'))
    name = path(1:n);    
    return;
  end
end

name = '.';

return;
