function f = fast_ldbslice(bstem,sliceno)
% f = fast_ldbslice(bstem,sliceno)

f = [];

if(nargin ~= 2)
  fprintf('USAGE: f = fast_ldbslice(bstem,sliceno)\n');
  return;
end

[nslices nrows ncols nt endian bext hdrdat] = fmri_bvoldim(bstem);
if(nslices == 0)
  fprintf('ERROR with bvolume %s\n',bstem);
  return;
end

if(sliceno >= nslices)
  fprintf('ERROR: requested slice %d exceeds number of slices %d\n',...
	  sliceno,nslices);
  return;
end

fname = sprintf('%s_%03d.%s',bstem,sliceno,bext);
f = fmri_ldbfile(fname);

return;
