function [nstd, hr, hi] = fmri_sfaunpack(sfaslice)
% [nstd hr hi] = fmri_sfaunpack(sfaslice)
%
% sfaslice: nrows ncols nplanes
%
% $Id$

if(nargin ~= 1)
  msg = '[nstd hr hi] = fmri_sfaunpack(sfaslice)';
  qoe(msg); error(msg);
end

[nrows ncols nplanes] = size(sfaslice);

nstd = sfaslice(:,:,1);

nfreq = (nplanes-1)/2;
indreal = [2:2+(nfreq-1)];
indimag = indreal + nfreq;
hr = sfaslice(:,:,indreal);
hi = sfaslice(:,:,indimag);


return;
